//	Using-the-USI-Module-as-a-I2C-Slave_ApplicationNote_AVR312
//	『昼夜逆転』工作室	http://jsdiy.webcrow.jp

#include <avr/io.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>
#include "usiTwiSlave.h"

#define	SLAVE_ADDRESS	0x3C	//例として

int	main(void)
{
	//USI-TWI機能を初期化する
	usiTwiSlaveInit(SLAVE_ADDRESS);
	
	sei();
    while (1) 
    {
		if (usiTwiDataInReceiveBuffer())
		{
			//データを受信した時に実行する内容をここに書く
			//・例えばこのスレーブデバイスがLCDなら表示処理。
			//・例えば温度センサーなら温度を読み取る。送信処理はここではない。
		}
		else
		{
			//受信バッファが空の時に実行する内容をここに書く
			//・スレーブデバイス固有の処理や送信処理など。
			//・受信バッファが空の時にusiTwiReceiveByte()を呼び出すと、
			//	何かを受信するまで処理がブロックされることに注意。
			
			//例えば何も処理がないときはスリープして消費電力を削減するとか
			set_sleep_mode(SLEEP_MODE_IDLE);
			sleep_mode();
		}
    }
	
	return (0);
}
